<?php
class JFormFieldConfigManager extends JFormField {
	protected $type = 'ConfigManager';
	protected function getInput() {
		if(!defined('DS')) {
			define('DS', DIRECTORY_SEPARATOR);
		}
	
		jimport('joomla.filesystem.file');
		// necessary Joomla! classes
		$uri = JURI::getInstance();
		$db = JFactory::getDBO();
		$app = JFactory::getApplication();

		// variables from URL
		$tpl_id = $uri->getVar('id', 'none');
		$task = $uri->getVar('gk_template_task', 'none');
		$file = $uri->getVar('gk_template_file', 'none');
		$base_path = str_replace('admin'.DS.'elements', '', dirname(__FILE__)).'config'.DS;

		// message
		$msg = '';
		// helping variables
		$redirectUrl = $uri->root() . 'administrator/index.php?option=com_templates&view=style&layout=edit&id=' . $tpl_id;
		// if the URL contains proper variables
		if($tpl_id !== 'none' && is_numeric($tpl_id) && $task !== 'none') {
			if($task == 'load') {
				if(JFile::exists($base_path . $file)) {
					//
					$query = '
						UPDATE 
							#__template_styles
						SET	
							params = '.$db->quote(file_get_contents($base_path . $file)).'
						WHERE 
						 	id = '.$tpl_id.'
						LIMIT 1
						';	
					// Executing SQL Query
					$db->setQuery($query);
					$result = $db->execute();
					// check the result
					if($result) {
						// make an redirect
						$app->enqueueMessage(JText::_('TPL_GK_LANG_CONFIG_LOADED_AND_SAVED'), 'message');
						$app->redirect($redirectUrl);
					} else {
						// make an redirect
						$app->enqueueMessage(JText::_('TPL_GK_LANG_CONFIG_SQL_ERROR'), 'error');
						$app->redirect($redirectUrl);
					}
				} else {
					// make an redirect
					$app->enqueueMessage(JText::_('TPL_GK_LANG_CONFIG_SELECTED_FILE_DOESNT_EXIST'), 'error');
					$app->redirect($redirectUrl);
				}	
			} else if($task == 'save') {
				if($file == '') {
					$file = date('d_m_Y_h_s');
				}
				// variable used to detect if the specified file exists
				$i = 0;
				// check if the file to save doesn't exist
				if(JFile::exists($base_path . $file . '.json')) {
					// find the proper name for the file by incrementing
					$i = 1;
					while(JFile::exists($base_path . $file . $i . '.json')) { $i++; }
				}	
				// get the settings from the database
				$query = '
					SELECT
						params AS params
					FROM 
						#__template_styles
					WHERE 
					 	id = '.$tpl_id.'
					LIMIT 1
					';	
				// Executing SQL Query
				$db->setQuery($query);
				$row = $db->loadObject();
				// write it
				if(JFile::write($base_path . $file . (($i != 0) ? $i : '') . '.json' , $row->params)) {
					// make an redirect
					$app->enqueueMessage(JText::_('TPL_GK_LANG_CONFIG_FILE_SAVED_AS'). ' '. $file . (($i == 0) ? '' : $i) .'.json', 'message');
					$app->redirect($redirectUrl);
				} else {
					// make an redirect
					$app->enqueueMessage(JText::_('TPL_GK_LANG_CONFIG_FILE_WASNT_SAVED_PLEASE_CHECK_PERM'), 'error');
					$app->redirect($redirectUrl);
				}
			} else if($task == 'delete') {
				// Check if file exists before deleting
				if(JFile::exists($base_path . $file)) {
					if(JFile::delete($base_path . $file)) {						
						$app->enqueueMessage($file . ' ' . JText::_('TPL_GK_LANG_CONFIG_FILE_DELETED_AS'), 'message');
						$app->redirect($redirectUrl);
					} else {
						$app->enqueueMessage($file . ' ' . JText::_('TPL_GK_LANG_CONFIG_FILE_WASNT_DELETED_PLEASE_CHECK_PERM'), 'error');
						$app->redirect($redirectUrl);
					}
				} else {
					$app->enqueueMessage($file . ' ' . JText::_('TPL_GK_LANG_CONFIG_FILE_WASNT_DELETED_PLEASE_CHECK_FILE'), 'error');
					$app->redirect($redirectUrl);
				}	
			}
		}
		// generate the select list
		$options = (array) $this->getOptions();
		$file_select = JHtml::_('select.genericlist', $options, 'name', 'class="form-control custom-select"', 'value', 'text', 'default', 'config_manager_load_filename');
		$file_delete = JHtml::_('select.genericlist', $options, 'name', 'class="form-control custom-select"', 'value', 'text', 'default', 'config_manager_delete_filename');
		// return the standard formfield output
		$html = '';
		$html .= '<div id="gk-social"><span>Follow us on the social media: </span> <iframe src="//www.facebook.com/plugins/like.php?href=http%3A%2F%2Ffacebook.com%2Fgavickpro&amp;send=false&amp;layout=button_count&amp;width=150&amp;show_faces=false&amp;font=arial&amp;colorscheme=light&amp;action=like&amp;height=21" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:100px; height:21px;" allowTransparency="true"></iframe> <a href="https://twitter.com/gavickpro" class="twitter-follow-button" data-show-count="false">Follow @gavickpro</a>
		<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?\'http\':\'https\';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+\'://platform.twitter.com/widgets.js\';fjs.parentNode.insertBefore(js,fjs);}}(document, \'script\', \'twitter-wjs\');</script></div>';
		$html .= '<div id="config_manager_form" class="card card-body bg-light">';
		$html .= '<div class="control-group"><label>'.JText::_('TPL_GK_LANG_CONFIG_LOAD').'</label><div class="input-group">'.$file_select.'<span class="input-group-btn"><button id="config_manager_load" class="btn btn-secondary"><i class="icon-download"></i> '.JText::_('TPL_GK_LANG_CONFIG_LOAD_BTN').'</button></span></div></div>';
		$html .= '<div class="control-group"><label>'.JText::_('TPL_GK_LANG_CONFIG_SAVE').'</label><div class="input-group"><input type="text" id="config_manager_save_filename" class="form-control" placeholder="'.JText::_('TPL_GK_LANG_CONFIG_YOUR_FILENAME').'" /><span class="input-group-addon">.json</span><span class="input-group-btn"><button id="config_manager_save" class="btn btn-secondary"><i class="icon-upload"></i> '.JText::_('TPL_GK_LANG_CONFIG_SAVE_BTN').'</button></span></div></div>';
		$html .= '<div class="control-group"><label>'.JText::_('TPL_GK_LANG_CONFIG_DELETE').'</label><div class="input-group">'.$file_delete.'<span class="input-group-btn"><button id="config_manager_delete" class="btn btn-secondary"><i class="icon-remove"></i> '.JText::_('TPL_GK_LANG_CONFIG_DELETE_BTN').'</button></span></div></div>';
		$html .= '<div><p><span class="label label-warning">'.JText::_('TPL_GK_LANG_CONFIG_DIRECTORY').'</span> <span>'.str_replace(DS, ' ' . DS . ' ', $base_path).'</span></p></div>';
		$html .= '</div>';
		// finish the output
		return $html;
	}
	protected function getOptions() {
		jimport('joomla.filesystem.folder');
		
		$base_path = str_replace('admin'.DS.'elements', '', dirname(__FILE__)).'config'.DS;
	
		$options = array();
		//$path = (string) $this->element['directory'];
		//if (!is_dir($path)) $path = JPATH_ROOT.'/'.$path;
		$files = JFolder::files($base_path, '.json');
		if (is_array($files)) {
			foreach($files as $file) {
				$options[] = JHtml::_('select.option', $file, $file);
			}
		}
		return array_merge($options);
	}
}
/* EOF */